/*	
 *	clippce.h
 *
 *	P/ECEp[`W߂܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Wed Apr 24 09:26:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	* Sun Jul 28 11:16:00 JST 2002 Naoyuki Sawa
 *	- PAD_AB/TRG_AB̒`ǉB
 */
#ifndef __CLIP_PCE_H__
#define __CLIP_PCE_H__

/*****************************************************************************
 *	萔E}N
 *****************************************************************************/

#define BLOCKSIZE	4096	/* tbṼZN^TCY */

#define PAD_MASK	0x00FF	/* PAD_A|B|START|SELECT */
#define TRG_MASK	0xFF00	/* TRG_A|B|START|SELECT */
#define PAD_AB		(PAD_A | PAD_B)
#define TRG_AB		(TRG_A | TRG_B)

#define DI do { DISABLE; bWD_WP_WRWD = 1; bWD_EN_EWD = 0; } while(0) /* 荞݋֎~(NMI) */
#define EI do { ENABLE ; bWD_WP_WRWD = 1; bWD_EN_EWD = 1; } while(0) /* 荞݋(NMI) */

extern unsigned char _def_vbuff[]; /* ėp[NƂėp(pceapi.libɂ܂) */

/* RAMւ̃R[h̃Rs[/NA (\usr\PIECE\pcekn\pcekn.h) */
#define FRAMCOPY(dstsect,srcsect)\
{\
extern unsigned long __START_##dstsect[];\
extern unsigned long __START_##srcsect[];\
extern unsigned long __SIZEOF_##srcsect[];\
	memcpy(\
		&__START_##dstsect,\
		&__START_##srcsect,\
		(unsigned)&__SIZEOF_##srcsect\
	);\
}
#define FRAMCLEAR(dstsect,srcsect)\
{\
extern unsigned long __START_##dstsect[];\
extern unsigned long __SIZEOF_##srcsect[];\
	memset(\
		&__START_##dstsect,\
		0,\
		(unsigned)&__SIZEOF_##srcsect\
	);\
}

/*****************************************************************************
 *	P/ECEpE[maint[[N
 *****************************************************************************/

/* AvP[V`̃Gg|CgłB
 * [out]
 *	߂l		IR[hB
 * [note]
 *	* AvP[VIɂ́Aʂ̕@܂B
 *	  1. main()ԂB
 *	  2. pceAppReqExit()Ă񂾌Ayield()ĂԁB
 */
int main();

/* VXeɐ܂B
 * [note]
 *	* AvP[V́AIyield()Ă΂Ȃ΂܂B
 */
void yield();

/* vOIɎs֐w肵܂B
 * [in]
 *	func		֐ւ̃|C^B
 * [out]
 *	߂l		o^ł0Ԃ܂B
 *			s0ȊO̒lԂ܂B
 * [note]
 *	* ݂̎ł́Ao^ł֐͈łB
 *	  Ȃ킿Aatexit()𕡐ĂԂƁAڈȍ~͎s܂B
 */
int atexit(void (*func )());

/*****************************************************************************
 *	[eBeBF^C}
 *****************************************************************************/

/* }CNbPʂ̎ԑ҂s܂B
 * [in]
 *	usec		҂[}CNb]
 * [note]
 *	* xJEgipceTimerAdjustPrecisionCount()j̒ĺA
 *	  16bit^C}̃JE^f[^ClockTicksl琶Ă܂B
 *	* ǂ̒l荞݋֎~JEgAbvp̂ŁA
 *	  荞݋֎~łusleep()gĎԑ҂sƂł܂B
 */
void usleep(unsigned long usec);

/*****************************************************************************
 *	[eBeBF`
 *****************************************************************************/

/* LCDCď܂B
 * [note]
 *	* ݂P/ECEJ[l(BIOS 1.18)ł́AAvP[VN邽тɁA
 *	  ʂ̔ZxoĂ܂Ƃ܂B
 *	* dAxłZbg{^ƁAZxo͂߂܂B
 *	* Zx̃ohɂ́ARESETB[qgLCDCď܂B
 *	  iP/ECEJ[ĺAResetR}hgĂ܂Ał̓_łj
 *	* ̊֐AAvP[VNɌĂяoĂB
 *	  RESETB[qgLCDCďAmɔZx̃oC܂B
 *	  gݍ݂pceAppInit()Ăяo悤ɂ܂B
 *	    AAvP[VvO璼ڌĂяoKv͂܂B
 *	* RESETBɂ郊ZbǵAOFFEVRAMNA𔺂̂ŁAӂB
 */
void lcd_init();

/* ݂̉zʂɁAIuWFNg`܂B
 * [in]
 *	src		]rbg}bvB
 *	dx,dy		]̍WB
 *	sx,sy		]̍WB
 *	w,h		]TCYB
 *	param		p[^B
 * [note]
 *	* pceLCDSetObject()/pceLCDDrawObject()̃yAĂяołB
 *	  ̈Ӗ́ApceLCDSetObject()ƓłB
 */
void draw_object(PIECE_BMP* src, int dx, int dy, int sx, int sy, int w, int h, int param);

/* _[w肵āAIuWFNg`܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	dx,dy		]̍WB
 *	sx,sy		]̍WB
 *	w,h		]TCYB
 *	param		p[^B
 * [note]
 *	* render͗\render_init()ɂďĂȂ΂܂B
 *	* `̈́Arenderɐݒ肳ꂽr[|[g`ɃNbsO܂B
 *	* rendeř݂̃ReLXgɃeNX`ݒ肳ĂȂ΂܂B
 *	  eNX`ݒ肹ɂ̊֐ĂԂƁAG[\Ē~܂B
 *	* ʏ̉ʃQ[ł́AAvP[VɃT[tFCX͈ȂA
 *	  pceLCDSetBuffer()RENDER͓T[tFCXwĂ̂ŁÅ֐gKv͂܂B
 *	  draw_object()ŏ[łB
 *	  cʃQ[̏ꍇ́AC[`ڏcϊӎȂ`悷A
 *	  cT[tFCXɕ`悵AT[tFCXɕϊē]JyłB
 *	  pceLCDSetBuffer()128x88̉T[tFCXARENDER88x128̏cT[tFCXwƂɂȂ܂B
 *	  ̂悤ȃP[XŁApceLCDSetBuffer()Ɏw肵T[tFCXȊOɃIuWFNg`悷邽߂ɁA
 *	  render_object()pӂ܂B
 *	* ̊֐render_vtBNXĂ܂Acliprend.h/cɂ͊܂߂܂łB
 *	  ̗ŔÅ֐pceLCDDrawObject()ɈˑĂāAڐAȂłB
 *	  pceLCDDrawObject()̑啔͎O̍łɒuĂ̂łA
 *	  ܂1bit`ȃp[^̏IWipceLCDDrawObject()ɈˑĂ܂B
 *	  ]āÅ֐͂܂cliprend.h/cɂ͊܂߂ȂƔf܂B
 */
void render_object(RENDER* render, int dx, int dy, int sx, int sy, int w, int h, int param);

/****************************************************************************
 *	[eBeBFtHg
 ****************************************************************************/

/* tHg`܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x,y		`ʒu̍WB
 *	code		R[hB(VtgJIS)
 *			p̏ꍇ́AʃoCgɕR[hāAʃoCg0ƂĂB
 *			Sp̏ꍇ́A1oCgڂʃoCgA2oCgڂʃoCgɓĂB
 *	type		tHg̎ށB(bit31`7͖܂)
 *			0x00: 5x10(p)܂10x10(Sp)
 *			0x01: 8x16(p)
 *			0x02: 4x 6(p)
 *	color		tHg̐FB
 *			0: 
 *			1: D
 *			2: ÊD
 *			3: 
 * [out]
 *	߂l		8rbgɕ`悵tHg̕  [sNZ]A
 *			8rbgɕ`悵tHg̍[sNZ]Ԃ܂B
 * [note]
 *	* `̈́Arenderɐݒ肳ꂽr[|[g`ɃNbsO܂B
 *	* render_string(),render_printf()Ƃ͖߂l̃rbgقȂ̂ŁAӂB
 *	* ̊֐͓pceFontSetType()ĂяoĂ܂B
 *	  ̊֐ĂяoƁAtHg^Cv̐ݒ肪ύX̂ŁAӂB
 *	* ̊֐render_vtBNXĂ܂Acliprend.h/cɂ͊܂߂܂łB
 *	  pceFonSetType()/pceFontGetAdrs()P/ECẼtHgf[^ɈˑĂ邩łB
 */
unsigned short render_font(RENDER* render, int x, int y, unsigned short code, int type, int color);

/* `܂B
 *	render		_[ւ̃|C^B
 *	x,y		`ʒu̍WB
 *	str		ւ̃|C^B
 *	type		tHg̎ށB
 *			0x00: 5x10(p)܂10x10(Sp) s
 *			0x01: 8x16(p)                  s
 *			0x02: 4x 6(p)                  s
 *			0x80: 5x10(p)܂10x10(Sp) sȂ
 *			0x81: 8x16(p)                  sȂ
 *			0x82: 4x 6(p)                  sȂ
 *	color		tHg̐FB
 *			0: 
 *			1: D
 *			2: ÊD
 *			3: 
 * [out]
 *	߂l		16rbgɕ`悵tHg̕  [sNZ]A
 *			16rbgɕ`悵tHg̍[sNZ]Ԃ܂B
 * [note]
 *	* `̈́Arenderɐݒ肳ꂽr[|[g`ɃNbsO܂B
 *	* render_font()Ƃ͖߂l̃rbgقȂ̂ŁAӂB
 *	* ̊֐͓pceFontSetType()ĂяoĂ܂B(render_font()ɂ)
 *	  ̊֐ĂяoƁAtHg^Cv̐ݒ肪ύX̂ŁAӂB
 *	* ̊֐render_vtBNXĂ܂Acliprend.h/cɂ͊܂߂܂łB
 *	  pceFonSetType()/pceFontGetAdrs()P/ECẼtHgf[^ɈˑĂ邩łB
 */
unsigned int render_string(RENDER* render, int x, int y, const char* str, int type, int color);

/* t`܂B
 *	render		_[ւ̃|C^B
 *	x,y		`ʒu̍WB
 *	type		tHg̎ށB
 *			0x00: 5x10(p)܂10x10(Sp) s
 *			0x01: 8x16(p)                  s
 *			0x02: 4x 6(p)                  s
 *			0x80: 5x10(p)܂10x10(Sp) sȂ
 *			0x81: 8x16(p)                  sȂ
 *			0x82: 4x 6(p)                  sȂ
 *	color		tHg̐FB
 *			0: 
 *			1: D
 *			2: ÊD
 *			3: 
 *	fmt		w蕶ւ̃|C^B
 *	...		p[^B
 * [out]
 *	߂l		16rbgɕ`悵tHg̕  [sNZ]A
 *			16rbgɕ`悵tHg̍[sNZ]Ԃ܂B
 * [note]
 *	* `̈́Arenderɐݒ肳ꂽr[|[g`ɃNbsO܂B
 *	* render_font()Ƃ͖߂l̃rbgقȂ̂ŁAӂB
 *	* ̊֐́AtWJ邽߂ɁA_def_vbuff[]𗘗pĂ܂B
 *	  _def_vbuff[]zʂƂĐݒ肵ĂꍇAʍɃS~o܂B
 *	* ̊֐͓pceFontSetType()ĂяoĂ܂B(render_font()ɂ)
 *	  ̊֐ĂяoƁAtHg^Cv̐ݒ肪ύX̂ŁAӂB
 *	* ̊֐render_vtBNXĂ܂Acliprend.h/cɂ͊܂߂܂łB
 *	  pceFonSetType()/pceFontGetAdrs()P/ECẼtHgf[^ɈˑĂ邩łB
 */
unsigned int render_printf(RENDER* render, int x, int y, int type, int color, const char* fmt, ...);

/* tHg//t`܂B
 * [in]
 *	color		0c0ccccbbbbaaaa  e4bitłI8bitȂI
 *			    ||||||||++++- 
 *			    |||||+++----- ()
 *			    +++++-------- (p̕)
 *			wiɁAEŕ`ȂA0x130łB
 *			wiɁAEŕ`ȂA0x203łB
 *	colorȊÖɂẮArender_font()/render_string()/render_printf()ƓłB
 *	render_font()/render_string()/render_printf()̐QƂĂB
 * [out]
 *	߂l		render_font()/render_string()/render_printf()ƓA`TCYԂ܂B
 *			L֐̖߂lɊrׂāA̕Ac2sNZÂ傫ȒlԂ܂B
 *			A`Ȃ̏ꍇ́AL֐ƓA0Ԃ܂B
 */
unsigned short render_font_framed(RENDER* render, int x, int y, unsigned short code, int type, int color);
unsigned int render_string_framed(RENDER* render, int x, int y, const char* str, int type, int color);
unsigned int render_printf_framed(RENDER* render, int x, int y, int type, int color, const char* fmt, ...);

/*****************************************************************************
 *	[eBeBFTEh
 *****************************************************************************/

/* TEhĐ܂B
 * [in]
 *	ch		`lԍ(0`3)
 *	data		TEhf[^̐擪AhX
 * [note]
 *	* pceWaveOut()ɓnPCEWAVEINFOƂẮAdataPCEWAVEINFO͒ڎgĂ܂B
 *	  sound_play()PCEWAVEINFOɃRs[ĂpceWaveOut()ɓnĂ܂B
 *	  ]āATEhf[^𕡐̃`lœɍĐĂvłB
 *	* TEhf[^pPCMConv.exȅo͌`݊ƂĂBA
 *	  +0`:VOl`('PPCM')
 *	       f[^{(PCEWAVEINFOƃTvf[^)̃TCY
 *	  +8`:PCEWAVEINFO(pDataȊÕtB[h͏ς݂ł邱)
 *	       Tvf[^
 *	  ƂȂĂKv܂Bldppcmcnv.exȅo͂̌`łB
 *	* ȂPCEWAVEINFOn܂悤RAW`f[^w肷ƁA
 *	  ssound_play()̃VOl``FbNŃAT[g܂B
 */
void sound_play(int ch, const unsigned char* data);

/* TEh~܂B
 * [in]
 *	ch		`lԍ(0`3)
 */
void sound_stop(int ch);

/****************************************************************************
 *	[eBeBFXg[Đ
 ****************************************************************************/

/* [U[pӂAXg[ĐR[obN֐̌^錾łB
 * [in]
 *	wbuff		ɃTvf[^WJĂB
 *			Tv`͕t16bit(PW_TYPE_16BITPCM)ɌŒłB
 *			Tvstream_play()BLKSɎw肵TvłB
 *	param		stream_play()Ɏw肵paraml̂܂ܓn܂B
 * [out]
 *	߂l		Tvf[^̓WJɐA 0ԂĂB
 *			Tvf[^̓WJɎsA-1ԂĂB
 *			s󋵂Ƃ́AtIf[^ĂꍇȂǂłB
 * [note]
 *	* R[obN֐-1Ԃꍇ́AXg[Đ[`Ńobt@NAA
 *	  Ԃɂ܂̂ŁAR[obN֐Ńobt@NAKv͂܂B
 *	* R[obN֐1(s)ԂĂA܂ɃR[obNs܂B
 *	  s̉񕜂oȂꍇ́A-1Ԃ悤ɃR[obN쐬ĂB
 */
typedef int STREAMCALLBACK(short* wbuff, int param);

/* Xg[ĐJn܂B
 * [in]
 *	BLKS		R[obN񓖂̓WJTvBioCgł͂܂Ij
 *			pceWave*()̎ɗR鐧ɂA64̔{łȂ΂܂B
 *	param		R[obNɓnACӂ̃p[^w肷邱Ƃł܂B
 * [note]
 *	* ɃXg[ĐAIstream_stop()Ă΂܂B
 *	* ݂̎ł́AXg[Đɗp`ĺA`l#0ɌŒłB
 *	* stream_play()̓A܏̃R[obNs܂B
 *	  ̊֐ĂԑOɁAR[obNTvWJł悤AĂĂB
 *	* stream_play()ĂԂƁATEh荞݃xN^tbN܂B
 *	  vOIOɕKstream_stop()ĂŁAxN^𕜌ĂB
 */
void stream_play(int BLKS, STREAMCALLBACK callback, int param);

/* Xg[ĐI܂B
 * [note]
 *	* Xg[ĐłȂ΁A܂B
 *	* R[obÑ\[XJɂ͊֒m܂̂ŁAYꂸ\[XJsĂB
 *	  Ŝ̗ƂẮÂ悤ɂȂ܂B
 *		ETvWJp̃\[XmہER[obN
 *		Estream_play()
 *		EiR[obN~mj
 *		Estream_stop()
 *		ETvWJp̃\[XJ
 */
void stream_stop();

/****************************************************************************
 *	[eBeBFt@C
 ****************************************************************************/

/* ZN^ɈˑȂAt@Cǂݍ݊֐łB
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	ptr		obt@|C^B
 *	ofs		t@C擪̃oCgItZbgB
 *	len		ǂݍރoCgB
 * [out]
 *	߂l		ǂݍ񂾃oCgB
 *			ǂݍ݂Ɏs0Ԃ܂B
 * [note]
 *	* ZN^E܂œǂݍނƂł܂B
 */
int file_read(FILEACC* fa, void* ptr, int ofs, int len);

/* ZN^ɈˑȂAt@C݊֐łB
 * [in]
 *	fa		FILEACC\́B(FOMD_WRŊJĂ)
 *	ptr		obt@|C^B
 *	ofs		t@C擪̃oCgItZbgB
 *	len		ރoCgB
 * [out]
 *	߂l		񂾃oCgB
 *			݂Ɏs0Ԃ܂B
 * [note]
 *	* ZN^E܂ŏނƂł܂B
 *	* ̃t@CêA܂Ȃ͕ωA̓eێ܂B
 *	  pceFileWriteSct()gꍇ́AZN^̏܂Ȃ͏܂B
 */
int file_write(FILEACC* fa, const void* ptr, int ofs, int len);

/* t@CpbNt@CT܂B
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	fnmame		t@CB
 * [out]
 *	߂l		t@Cւ̃|C^Ԃ܂B
 *			ȂNULLԂ܂B
 * [note]
 *	* ̊֐Ԃt@Cւ̃|C^́A
 *	  ֐staticϐ̈wĂ܂B
 *	  Å֐Ă񂾂Ƃɔj󂳂܂̂ŁA
 *	  KvȂΌĂяoŃRs[ĂB
 */
FILE_INFO* fpak_find(FILEACC* fa, const char* fname);

/* tbVŘAȃZN^ɔzuꂽt@C̐擪AhX擾܂B
 * [in]
 *	fname		t@CB
 * [out]
 *	߂l		t@C݂AAZN^ɔzuĂA擪AhXԂ܂B
 *			t@C݂ȂAsAZN^ɔzuĂANULLԂ܂B
 */
const void* file_address(const char* fname);

/****************************************************************************
 *	zlibWJ -> clipzlib.c
 ****************************************************************************/

/* t@CɊ܂܂鈳kf[^WJ܂B
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	outbuf		WJobt@B
 *	outlen		WJobt@TCYB
 *	inofs		kf[^̐擪ItZbgB
 *	inlen		kf[^̃oCgB
 *			0w肷ƁAinofst@CI[܂łƌȂ܂B
 * [out]
 *	߂l		WJ̃oCgB
 *			WJɎs0Ԃ܂B
 */
int file_inflate(FILEACC* fa, void* outbuf, int outlen, int inofs, int inlen);

/* t@CɊ܂܂鈳kf[^̓WJTCY𒲂ׂ܂B
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	inofs		kf[^̐擪ItZbgB
 *	inlen		kf[^̃oCgB
 *			0w肷ƁAinofst@CI[܂łƌȂ܂B
 * [out]
 *	߂l		WJ̃oCgB
 *			WJɎs0Ԃ܂B
 */
int file_inflate_size(FILEACC* fa, int inofs, int inlen);

/* t@CpbNɊ܂܂鈳kf[^WJ܂B
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	outbuf		WJobt@B
 *	outlen		WJobt@TCYB
 *	fname		t@CB
 * [out]
 *	߂l		WJ̃oCgB
 *			WJɎs0Ԃ܂B
 */
int fpak_inflate(FILEACC* fa, void* outbuf, int outlen, const char* fname);

/* t@CpbNɊ܂܂鈳kf[^̓WJTCY𒲂ׂ܂B
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	fname		t@CB
 * [out]
 *	߂l		WJ̃oCgB
 *			WJɎs0Ԃ܂B
 */
int fpak_inflate_size(FILEACC* fa, const char* fname);

/* ̃f[^k܂B
 * [in]
 *	out		kobt@B
 *	outlen		kobt@TCYݒ肳ꂽϐւ̃|C^B
 *	in		f[^obt@B
 *	inlen		f[^TCYB
 * [out]
 *	߂l		ȂZ_OKB
 *			sȂZ_OKȊO̒lԂ܂B
 *	*out		Ȃ爳kf[^i[܂B
 *			sȂe͕sƂȂ܂B
 *	*outlen		Ȃ爳kf[^TCYi[܂B
 *			sȂe͕sƂȂ܂B
 * [note]
 *	* k͓WJȏɍƗpKvƂ̂ŁA
 *	  zlibWcompress()compress2()ł́Asŗpł܂B
 *	- ܂Azlib 1.1.4 ɂ́AdeflateInit2()̃G[ɖ肪悤łB
 *	  deflateInit2()ŃG[NƁAzlibŃ[NĂ܂܂B
 *	  deflateInit2()gĂAcompress()compress2()lłB
 *	- deflateInit2()ŝ͂ĂAƗpȂꍇłB
 *	  ȏ̗RɂAȃݒ̈k֐pӂ邱Ƃɂ܂B
 *	- ȂAłƗps邱Ƃ͂܂B
 *	  kf[^TCYɔႵƗpKvɂȂ悤ŁA
 *	  8KB̃f[^kɂ́A16KBx̍ƗpKvłB
 *	  傫ȃf[^k悤ƂƁAdeflateInit2()sA[N܂B
 *	  ̊֐sꍇ́AbZ[W\AvOISłB
 *	* my_compress()ĂԑOɁA*outlenkobt@TCYݒ肵Ă̂YȂŁI
 *	* WJɂ́AzlibWuncompress()̂܂܎gĂB
 */
int my_compress(void* out, int* outlen, const void* in, int inlen);

/****************************************************************************
 *	GSMĐ -> clipgsm.c
 ****************************************************************************/

/* GSMt@C̍ĐJn܂B
 * [in]
 *	ch		Đ`lB(0`3)
 *	fname		GSMt@CB
 *	loop		[v񐔁B(-1:,0:ĐȂ,1`:[v)
 * [out]
 *	߂l		ĐJnł0Ԃ܂B
 *			s-1Ԃ܂B(t@CȂA)
 */
int gsm_play(int ch, const char* fname, int loop);

/* GSMt@C̍Đ~܂B
 * [note]
 *	* ĐłȂ΁Å֐͉܂B
 */
void gsm_stop();

/****************************************************************************
 *	P/ECE MOD Stream -> clipmod.c
 ****************************************************************************/

/* MODt@C̍ĐJn܂B
 * [in]
 *	data		MODf[^̐擪AhXA܂MODt@CB
 * [out]
 *	߂l		ĐJnɐA 0Ԃ܂B
 *			ĐJnłȂ΁A-1Ԃ܂B
 * [note]
 *	* ܂AdataMODf[^̂̂wĂƉ肵ďs܂B
 *	  (MODf[^sɂ)sAMODt@CƉ肵čď݂܂B
 *	  t@CƌȂčďŝ́Ap̎菇ȗ邽߂łA
 *	  Ŝ߁AȂׂMODf[^̂̂̃AhXw肷悤ɂĂB
 *	* ̊֐͓stream_play()ĂяoĂ܂B
 *	* stream_play()ĂԂƁATEh荞݃xN^tbN܂B
 *	  vOIOɕKmod_stop()ĂŁAxN^𕜌ĂB
 */
int mod_play(const void* data);

/* MODt@C̍Đ~܂B
 * [note]
 *	* ĐłȂ΁Å֐͉܂B
 */
void mod_stop();

#endif /*__CLIP_PCE_H__*/
